# Command Line Arguments

## Pine

Pine and PC-Pine can accept quite a few command-line arguments. Many of these arguments overlap with variables in the Pine configuration file. If there is a difference, then a flag set in the command line takes precedence. Both Pine and PC-Pine expect command line arguments (other than addresses) to be preceded by the "-" (dash) as normally used by UNIX programs.

[addresses]
  Send-to: If you give Pine an argument or arguments which do not begin with a dash, Pine treats them as email addresses. Pine will startup in the composer with a message started to the addresses specified. Once the message is sent, the Pine session closes. Standard input redirection is allowed. Separate multiple addresses with a space between them. Addresses are placed in the "To" field only.

< file
  Pine will startup in the composer with file read into the body of the message. Once the message is sent, the Pine session closes.

-attach file
  Go directly into composer with given file attached.

-attachlist file-list
  Go directly into composer with given files attached. This must be the last option on the command line.

-attach_and_delete file
  Go directly into composer with given file attached, delete when finished.

-aux local_directory
  PC-Pine only. This tells PC-Pine the local directory to use for storing auxiliary files, like debug files, address books, and signature files. The pinerc may be local or remote.

-nosplash
  PC-Pine only. This tells PC-Pine to not display the splash screen upon startup. This may be helpful for certain troubleshooting or terminal server scenarios.

-bail
  If the personal configuration file doesn't already exist, exit. This might be useful if the configuration file is accessed using some remote filesystem protocol. If the remote mount is missing this will cause Pine to quit instead of creating a new pinerc.

-c n
  When used with the `-f` option, apply the nth context. This is used when there are multiple folder collections (contexts) and you want to open a folder not in the primary collection.

-conf
  Configuration: Prints a sample system configuration file to the screen or standard output. To generate an initial system configuration file, execute

      		pine -conf > /usr/local/lib/pine.conf

  To generate a system configuration file using settings from an old system configuration file, execute

      		pine -P old-pine.conf -conf > /usr/local/lib/pine.conf

  A system configuration file is not required.

-convert_sigs -p pinerc
  Convert signatures contained in signature files into literal signatures.

-copy_abook <local_abook_file> <remote_abook_folder>
  Copy an address book file to a remote address book folder. If the remote folder doesn't exist, it will be created. If it exists but the first message in the folder isn't a remote address book header message, the copy will be aborted. This flag will not usually be used by a user. Instead, the user will create a remote address book from within Pine and copy entries from the local address book by using aggregate Save in the address book screen.

-copy_pinerc <local_pinerc_file> <remote_pinerc_folder>
  Copy a pinerc configuration file to a remote pinerc folder. If the remote folder doesn't exist, it will be created. If it exists but the first message in the folder isn't a remote pinerc header message, the copy will be aborted. This flag may be useful to users who already have a local pinerc file and would like to convert it to a remote pinerc folder and use that instead. This gives a way to bootstrap that conversion without having to manually reset all of the variables in the remote pinerc folder.

-create_lu addrbook sort-order
  Create auxiliary LookUp (index) file for addrbook and sort addrbook in sort-order, which may be dont-sort, nickname, fullname, nickname-with-lists-last, or fullname-with-lists-last. Only useful when creating global or shared address books. The settings of the features disable-setlocale-collate and enable-setlocale-ctype have no effect when using the create_lu command. See Address Book Lookup File for more information, especially the warning about copying the address book after creating the lookup file.

-d debug-level
  Debug Level: Sets the level of debugging information written by Pine. Debug-level can be set to any integer 0-9. A debug level of 0 turns off debugging for the session. (Actually there are some levels higher than 9, but you probably don't want to see them. Sensitive authentication information is hidden at levels less than 10.)

-d keywords
  You may use a more detailed version of the debugging flag to set the debug level in separate parts of Pine. The possibilities are flush, timestamp, imap=0..4, tcp, numfiles=0..31, and verbose=0..9. Flush causes debugging information to be flushed immediately to the debug file as it is written. Verbose is the general debugging verbosity level. Timestamp causes timestamps to be added to the debug file, which is useful when you are trying to figure out what is responsible for delays. Numfiles sets the number of debug files saved. Imap sets the debug level for the debugging statements related to the conversation with the IMAP server, and more generally, for the debugging related to Pine's interaction with the C-Client library. If imap is set higher than 4, sensitive authentication information will be included in the debug file. Tcp adds more TCP/IP debugging information.

-f folder
  Startup folder: Pine will open this folder in place of the standard INBOX.

-F file
  Open named text file for viewing and forwarding.

-h
  Help: Prints the list of available command-line arguments to the screen.

-i
  Pine will start up in the FOLDER INDEX screen instead of the MAIN MENU.

  Configuration equivalent: initial-keystroke-list=i.

-I a,b,c,...
  Initial Keystrokes: Pine will execute this comma-separated sequence of commands upon startup. This allows users to get Pine to start in any of its menus/screens. You cannot include any input to the composer in the initial keystrokes. The key <Return> is represented by a ``CR'' in the keystroke list; the spacebar is designated by the letters ``SPACE''. Control keys are two character sequences beginning with ``^'', such as ``^I''. A tab character is ``TAB''. Function keys are ``F1'' - ``F12'' and the arrow keys are ``UP'', ``DOWN'', ``LEFT'', and ``RIGHT''. A restriction is that you can't mix function keys and character keys in this list even though you can, in some cases, mix them when running Pine. A user can always use only character keys in the startup list even if he or she is using function keys normally, or vice versa. If an element in this list is a string of characters surrounded by double quotes (") then it will be expanded into the individual characters in the string, excluding the double quotes.

  Configuration equivalent: initial-keystroke-list

-install
  For PC-Pine only, this option prompts for some basic setup information, then exits.

-k
  Function-Key Mode: When invoked in this way, Pine expects the input of commands to be function-keys. Otherwise, commands are linked to the regular character keys.

  Configuration equivalent: use-function-keys included in feature-list.

-n n
  Message-Number: When specified, Pine starts up in the FOLDER INDEX screen with the current message being the specified message number.

-nowrite_passfile
  This tells Pine to use the passfile if there is one, but to never offer writing new passwords to the passfile.

-o folder
  Opens the INBOX (or a folder specified via the -f argument) ReadOnly.

-p pinerc
  Uses the named file as the personal configuration file instead of ~/.pinerc or the default PINERC search sequence PC-Pine uses. Pinerc may be either a local file or a remote configuration folder.

-P pinerc
  Uses the named file as the system wide configuration file instead of /usr/local/lib/pine.conf on UNIX, or nothing on PC-Pine. Pinerc may be either a local file or a remote configuration folder.

-passfile passfile
  This tells Pine what file should be used as the password file. This should be a fully-qualified filename.

-pinerc file
  Output fresh pinerc configuration to file, preserving the settings of variables that the user has made. Use file set to ``-'' to make output go to standard out.

-r
  Restricted Mode: For UNIX Pine only. Pine in restricted mode can only send email to itself. Save and export are limited.

-registry cmd
  For PC-Pine only, this option affects the values of Pine's registry entries. Possible values for cmd are set, noset, clear, clearsilent, and dump. Set will always reset Pine's registry entries according to its current settings. NoSet will never set any values in the registry, but it will still use the values already set in the registry. Clear will clear the registry values. Clearsilent will silently clear the registry values. Dump will display the values of current registry settings. Note that the dump command is currently disabled. Without the -registry option, PC-Pine will write values into the registry only if there currently aren't any values set.

-sort key
  Sort-Key: Specifies the order messages will be displayed in for the FOLDER INDEX screen. Key can have the following values: arrival, date, subject, orderedsubj, thread, from, size, score, to, cc, arrival/reverse, date/reverse, subject/reverse, orderedsubj/reverse, thread/reverse, from/reverse, size/reverse, score/reverse, to/reverse, and cc/reverse. The default value is "arrival". The key value reverse is equivalent to arrival/reverse.

  Configuration equivalent: sort-key.

-supported
  Some options may or may not be supported depending on how Pine was compiled. This is a way to determine which options are supported in the particular copy of Pine you are using.

-url url
  Open the given URL.

-v
  Version: Print version information to the screen.

-version
  Version: Print version information to the screen.

-x exceptions_config
  Configuration settings in the exceptions config override your normal default settings. Exceptions_config may be either a local file or a remote pinerc folder.

-z
  Enable Suspend: When run with this flag, the key sequence ctrl-z will suspend the Pine session.

  Configuration equivalent: enable-suspend included in feature-list.

-option=value
  Assign value to the config option option. For example, -signature-file=sig1 or -feature-list=signature-at-bottom. (Note: feature-list values are additive and features may be preceded with no- to turn them off).

## Pico

The following command line options are supported in Pico:

+n
  Causes Pico to be started with the cursor located n lines into the file. (Note: no space between "+" sign and number)

-a
  Display all files and directories, including those beginning with a period (.).

-b
  Enable the option to Replace text matches found using the "Where is" command.

-d
  Rebind the "delete" key so the character the cursor is on is rubbed out rather than the character to its left.

-e
  Enable file name completion.

-f
  Use function keys for commands. This option supported only in conjunction with UW Enhanced NCSA telnet.

-g
  Enable "Show Cursor" mode in file browser. Cause cursor to be positioned before the current selection rather than placed at the lower left of the display.

-k
  Causes "Cut Text" command to remove characters from the cursor position to the end of the line rather than remove the entire line.

-m
  Enable mouse functionality. This only works when Pico is run from within an X Window System "xterm" window.

-nn
  The -nn option enables new mail notification. The n argument is optional, and specifies how often, in seconds, your mailbox is checked for new mail. For example, -n60 causes Pico to check for new mail once every minute. The default interval is 180 seconds, while the minimum allowed is 30. (Note: no space between "n" and the number)

-o dir
  Sets operating directory. Only files within this directory are accessible. Likewise, the file browser is limited to the specified directory subtree.

-p
  Preserve the "start" and "stop" characters, typically Ctrl-Q and Ctrl-S, which are sometimes used in communications paths to control data flow between devices that operate at different speeds.

-q
  TermdefWins. Termcap or terminfo escape sequences are used in preference to default escape sequences.

-Q quotestr
  Set the quote string. Especially useful when composing email, setting this allows the quote string to be checked for when Justifying paragraphs. A common quote string is "> ".

-rn
  Sets column used to limit the "Justify" command's right margin.

-t
  Enable "tool" mode. Intended for when Pico is used as the editor within other tools (e.g., Elm, Pnews). Pico will not prompt for save on exit, and will not rename the buffer during the "Write Out" command.

-v
  View the file only, disallowing any editing.

-version
  Print version information.

-w
  Disable word wrap (thus allow editing of long lines).

  Note: Pico will break any lines over 255 characters when reading a file, regardless of word wrapping.

-x
  Disable keymenu at the bottom of the screen.

-z
  Enable ^Z suspension of Pico.

## Pilot

The following command line options are supported in Pilot:

-a
  Display all files including those beginning with a period (.).

-f
  Use function keys for commands. This option supported only in conjunction with UW Enhanced NCSA telnet.

-g
  Enable "Show Cursor" mode. Cause cursor to be positioned before the current selection rather than placed at the lower left of the display.

-m
  Enable mouse functionality. This only works when Pilot is run from within an X Window System "xterm" window.

-nn
  The -nn option enables new mail notification. The n argument is optional, and specifies how often, in seconds, your mailbox is checked for new mail. For example, -n60 causes Pilot to check for new mail once every minute. The default interval is 180 seconds, while the minimum allowed is 30. (Note: no space between "n" and the number)

-o dir
  Sets operating directory. Only files within the specified directory are accessible and browsing is limited to the specified directory subtree.

-v
  Enable single vertical column display.

-x
  Disable keymenu at the bottom of the screen.

-z
  Enable ^Z suspension of Pilot.